searchNodes=[{"doc":"Ewebmachine is a full rewrite with clean DSL and plug integration based on Webmachine from basho. This version is not backward compatible with the previous one that was only a thin wrapper around webmachine, use the branch 1.0-legacy to use the old one.The principle is to go through the HTTP decision tree and make decisions according to response of some callbacks called &quot;handlers&quot;.To do that, the library gives you 5 plugs and 2 plug pipeline builders :Ewebmachine.Plug.Run go through the HTTP decision tree and fill the conn response according to itEwebmachine.Plug.Send is used to send a conn set with Ewebmachine.Plug.RunEwebmachine.Plug.Debug gives you a debugging web UI to see the HTTP decision path taken by each request.Ewebmachine.Plug.ErrorAsException take a conn with a response set but not send, and throw an exception is the status code is an exceptionEwebmachine.Plug.ErrorAsForward take a conn with a response set but not send, and forward it changing the request to GET /error/pattern/:statusEwebmachine.Builder.Handlers gives you helpers macros and a :add_handler plug to add handlers as defined in Ewebmachine.Handlers to your conn, and set the initial user state.Ewebmachine.Builder.Resources gives you a resource macro to define at the same time an Ewebmachine.Builder.Handlers and the matching spec to use it, and a plug :resource_match to do the match and execute the associated plug. The macro resources_plugs helps you to define commong plug pipelingExample usagedefmodule MyJSONApi do use Ewebmachine.Builder.Handlers plug :cors plug :add_handlers, init: %{} content_types_provided do: [&quot;application/json&quot;: :to_json] defh to_json, do: Poison.encode!(state[:json_obj]) defp cors(conn,_), do: put_resp_header(conn,&quot;Access-Control-Allow-Origin&quot;,&quot;*&quot;) end defmodule ErrorRoutes do use Ewebmachine.Builder.Resources ; resources_plugs resource &quot;/error/:status&quot; do %{s: elem(Integer.parse(status),0)} after content_types_provided do: [&#39;text/html&#39;: :to_html, &#39;application/json&#39;: :to_json] defh to_html, do: &quot;&lt;h1&gt; Error ! : &#39;\#{Ewebmachine.Core.Utils.http_label(state.s)}&#39;&lt;/h1&gt;&quot; defh to_json, do: ~s/{&quot;error&quot;: \#{state.s}, &quot;label&quot;: &quot;\#{Ewebmachine.Core.Utils.http_label(state.s)}&quot;}/ finish_request do: {:halt,state.s} end end defmodule FullApi do use Ewebmachine.Builder.Resources if Mix.env == :dev, do: plug Ewebmachine.Plug.Debug resources_plugs error_forwarding: &quot;/error/:status&quot;, nomatch_404: true plug ErrorRoutes resource &quot;/hello/:name&quot; do %{name: name} after content_types_provided do: [&#39;application/xml&#39;: :to_xml] defh to_xml, do: &quot;&lt;Person&gt;&lt;name&gt;\#{state.name}&lt;/name&gt;&quot; end resource &quot;/hello/json/:name&quot; do %{name: name} after plug MyJSONApi #this is also a plug pipeline allowed_methods do: [&quot;GET&quot;,&quot;DELETE&quot;] resource_exists do: pass((user=DB.get(state.name)) !== nil, json_obj: user) delete_resource do: DB.delete(state.name) end resource &quot;/static/*path&quot; do %{path: Enum.join(path,&quot;/&quot;)} after resource_exists do: File.regular?(path state.path) content_types_provided do: [{state.path|&gt;Plug.MIME.path|&gt;default_plain,:to_content}] defh to_content, do: File.stream!(path(state.path),[],300_000_000) defp path(relative), do: &quot;\#{:code.priv_dir :ewebmachine_example}/web/\#{relative}&quot; defp default_plain(&quot;application/octet-stream&quot;), do: &quot;text/plain&quot; defp default_plain(type), do: type end endDebug UIGo to /wm_debug to see precedent requests and debug there HTTP decision path. The debug UI can be updated automatically on the requests.Use Cowboy to serve the plugCreate a simple supervision tree with only the Cowboy server adapter spec.defmodule MyApp do use Application def start(_type, _args), do: Supervisor.start_link([ Plug.Adapters.Cowboy.child_spec(:http,FullApi,[], port: 4000) ], strategy: :one_for_one) endAnd add it as your application entry point in your mix.exsdef application do [applications: [:logger,:ewebmachine,:cowboy], mod: {MyApp,[]}] end defp deps, do: [{:ewebmachine, &quot;2.0.0&quot;}, {:cowboy, &quot;~&gt; 1.0&quot;}]","ref":"Ewebmachine.html","title":"Ewebmachine","type":"module"},{"doc":"Set :resp_redirect to true","ref":"Ewebmachine.html#do_redirect/1","title":"Ewebmachine.do_redirect/1","type":"function"},{"doc":"Fetch request bodyOptions: max_length: maximum bytes to fetch (default: 1_000_000)","ref":"Ewebmachine.html#fetch_req_body/2","title":"Ewebmachine.fetch_req_body/2","type":"function"},{"doc":"Returns request body from request (requires fetching body first)","ref":"Ewebmachine.html#req_body/1","title":"Ewebmachine.req_body/1","type":"function"},{"doc":"use this module will use Plug.Builder (so a plug pipeline described with the plug module_or_function_plug macro), but gives you an :add_handler local function plug which adds to the conn the locally defined ewebmachine handlers (see Ewebmachine.Handlers).So : Construct your automate decision handler through multiple :add_handler plugsPipe the plug Ewebmachine.Plug.Run to run the HTTP automate which will call these handlers to take decisions. Pipe the plug Ewebmachine.Plug.Send to send and halt any conn previsously passed through an automate run.To define handlers, use the following helpers :the handler specific macros (like Ewebmachine.Builder.Handlers.resource_exists/1)the macro defh/2 to define any helpers, usefull for body producing handlers or to have multiple function clauses in handler implementation conn and state binding are availablethe response of the handler implementation is wrapped, so that returning :my_response is the same as returning {:my_response,conn,state}Below a full example :defmodule MyJSONApi do use Ewebmachine.Builder.Handlers plug :cors plug :add_handlers, init: %{} content_types_provided do: [&quot;application/json&quot;: :to_json] defh to_json, do: Poison.encode!(state[:json_obj]) defp cors(conn,_), do: put_resp_header(conn,&quot;Access-Control-Allow-Origin&quot;,&quot;*&quot;) end defmodule GetUser do use Ewebmachine.Builder.Handlers plug MyJSONApi plug :add_handlers plug Ewebmachine.Plug.Run plug Ewebmachine.Plug.Send resource_exists do: pass( !is_nil(user=DB.User.get(conn.params[&quot;q&quot;])), json_obj: user) end defmodule GetOrder do use Ewebmachine.Builder.Handlers plug MyJSONApi plug :add_handlers plug Ewebmachine.Plug.Run plug Ewebmachine.Plug.Send resource_exists do: pass(!is_nil(order=DB.Order.get(conn.params[&quot;q&quot;])), json_obj: order) end defmodule API do use Plug.Router plug :match plug :dispatch get &quot;/get/user&quot;, do: GetUser.call(conn,[]) get &quot;/get/order&quot;, do: GetOrder.call(conn,[]) end","ref":"Ewebmachine.Builder.Handlers.html","title":"Ewebmachine.Builder.Handlers","type":"module"},{"doc":"see Ewebmachine.Handlers.allow_missing_post/2","ref":"Ewebmachine.Builder.Handlers.html#allow_missing_post/1","title":"Ewebmachine.Builder.Handlers.allow_missing_post/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.allowed_methods/2","ref":"Ewebmachine.Builder.Handlers.html#allowed_methods/1","title":"Ewebmachine.Builder.Handlers.allowed_methods/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.base_uri/2","ref":"Ewebmachine.Builder.Handlers.html#base_uri/1","title":"Ewebmachine.Builder.Handlers.base_uri/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.charsets_provided/2","ref":"Ewebmachine.Builder.Handlers.html#charsets_provided/1","title":"Ewebmachine.Builder.Handlers.charsets_provided/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.content_types_accepted/2","ref":"Ewebmachine.Builder.Handlers.html#content_types_accepted/1","title":"Ewebmachine.Builder.Handlers.content_types_accepted/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.content_types_provided/2","ref":"Ewebmachine.Builder.Handlers.html#content_types_provided/1","title":"Ewebmachine.Builder.Handlers.content_types_provided/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.create_path/2","ref":"Ewebmachine.Builder.Handlers.html#create_path/1","title":"Ewebmachine.Builder.Handlers.create_path/1","type":"macro"},{"doc":"define a resource handler function as described at Ewebmachine.Handlers.Since there is a specific macro in this module for each handler, this macro is useful : to define body producing and body processing handlers (the one referenced in the response of Ewebmachine.Handlers.content_types_provided/2 or Ewebmachine.Handlers.content_types_accepted/2)to explicitly take the conn and the state parameter, which allows you to add guards and pattern matching for instance to define multiple clauses for the handlerdefh to_html, do: &quot;hello you&quot; defh from_json, do: pass(:ok, json: Poison.decode!(read_body conn))defh resources_exists(conn,%{obj: obj}) when obj !== nil, do: true defh resources_exists(conn,_), do: false","ref":"Ewebmachine.Builder.Handlers.html#defh/2","title":"Ewebmachine.Builder.Handlers.defh/2","type":"macro"},{"doc":"see Ewebmachine.Handlers.delete_completed/2","ref":"Ewebmachine.Builder.Handlers.html#delete_completed/1","title":"Ewebmachine.Builder.Handlers.delete_completed/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.delete_resource/2","ref":"Ewebmachine.Builder.Handlers.html#delete_resource/1","title":"Ewebmachine.Builder.Handlers.delete_resource/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.encodings_provided/2","ref":"Ewebmachine.Builder.Handlers.html#encodings_provided/1","title":"Ewebmachine.Builder.Handlers.encodings_provided/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.expires/2","ref":"Ewebmachine.Builder.Handlers.html#expires/1","title":"Ewebmachine.Builder.Handlers.expires/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.finish_request/2","ref":"Ewebmachine.Builder.Handlers.html#finish_request/1","title":"Ewebmachine.Builder.Handlers.finish_request/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.forbidden/2","ref":"Ewebmachine.Builder.Handlers.html#forbidden/1","title":"Ewebmachine.Builder.Handlers.forbidden/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.generate_etag/2","ref":"Ewebmachine.Builder.Handlers.html#generate_etag/1","title":"Ewebmachine.Builder.Handlers.generate_etag/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.is_authorized/2","ref":"Ewebmachine.Builder.Handlers.html#is_authorized/1","title":"Ewebmachine.Builder.Handlers.is_authorized/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.is_conflict/2","ref":"Ewebmachine.Builder.Handlers.html#is_conflict/1","title":"Ewebmachine.Builder.Handlers.is_conflict/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.known_content_type/2","ref":"Ewebmachine.Builder.Handlers.html#known_content_type/1","title":"Ewebmachine.Builder.Handlers.known_content_type/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.known_methods/2","ref":"Ewebmachine.Builder.Handlers.html#known_methods/1","title":"Ewebmachine.Builder.Handlers.known_methods/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.last_modified/2","ref":"Ewebmachine.Builder.Handlers.html#last_modified/1","title":"Ewebmachine.Builder.Handlers.last_modified/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.malformed_request/2","ref":"Ewebmachine.Builder.Handlers.html#malformed_request/1","title":"Ewebmachine.Builder.Handlers.malformed_request/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.moved_permanently/2","ref":"Ewebmachine.Builder.Handlers.html#moved_permanently/1","title":"Ewebmachine.Builder.Handlers.moved_permanently/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.moved_temporarily/2","ref":"Ewebmachine.Builder.Handlers.html#moved_temporarily/1","title":"Ewebmachine.Builder.Handlers.moved_temporarily/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.multiple_choices/2","ref":"Ewebmachine.Builder.Handlers.html#multiple_choices/1","title":"Ewebmachine.Builder.Handlers.multiple_choices/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.options/2","ref":"Ewebmachine.Builder.Handlers.html#options/1","title":"Ewebmachine.Builder.Handlers.options/1","type":"macro"},{"doc":"Shortcut macro for : {response,var!(conn),Enum.into(update_state,var!(state))}use it if your handler wants to add some value to a collectable state (a map for instance), but using default &quot;conn&quot; current binding.for instance a resources_exists implementation &quot;caching&quot; the result in the state could be :pass (user=DB.get(state.id)) != nil, current_user: user # same as returning : {true,conn,%{id: &quot;arnaud&quot;, current_user: %User{id: &quot;arnaud&quot;}}}","ref":"Ewebmachine.Builder.Handlers.html#pass/2","title":"Ewebmachine.Builder.Handlers.pass/2","type":"macro"},{"doc":"see Ewebmachine.Handlers.ping/2","ref":"Ewebmachine.Builder.Handlers.html#ping/1","title":"Ewebmachine.Builder.Handlers.ping/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.post_is_create/2","ref":"Ewebmachine.Builder.Handlers.html#post_is_create/1","title":"Ewebmachine.Builder.Handlers.post_is_create/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.previously_existed/2","ref":"Ewebmachine.Builder.Handlers.html#previously_existed/1","title":"Ewebmachine.Builder.Handlers.previously_existed/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.process_post/2","ref":"Ewebmachine.Builder.Handlers.html#process_post/1","title":"Ewebmachine.Builder.Handlers.process_post/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.resource_exists/2","ref":"Ewebmachine.Builder.Handlers.html#resource_exists/1","title":"Ewebmachine.Builder.Handlers.resource_exists/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.service_available/2","ref":"Ewebmachine.Builder.Handlers.html#service_available/1","title":"Ewebmachine.Builder.Handlers.service_available/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.uri_too_long/2","ref":"Ewebmachine.Builder.Handlers.html#uri_too_long/1","title":"Ewebmachine.Builder.Handlers.uri_too_long/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.valid_content_headers/2","ref":"Ewebmachine.Builder.Handlers.html#valid_content_headers/1","title":"Ewebmachine.Builder.Handlers.valid_content_headers/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.valid_entity_length/2","ref":"Ewebmachine.Builder.Handlers.html#valid_entity_length/1","title":"Ewebmachine.Builder.Handlers.valid_entity_length/1","type":"macro"},{"doc":"see Ewebmachine.Handlers.variances/2","ref":"Ewebmachine.Builder.Handlers.html#variances/1","title":"Ewebmachine.Builder.Handlers.variances/1","type":"macro"},{"doc":"use this module will use Plug.Builder (so a plug pipeline described with the plug module_or_function_plug macro), but gives you a :resource_match local function plug which matches routes declared with the resource/2 macro and execute the plug defined by its body.See Ewebmachine.Builder.Handlers documentation to see how to contruct these modules (in the after block)Below a full example : defmodule FullApi do use Ewebmachine.Builder.Resources if Mix.env == :dev, do: plug Ewebmachine.Plug.Debug # pre plug, for instance you can put plugs defining common handlers plug :resource_match plug Ewebmachine.Plug.Run # customize ewebmachine result, for instance make an error page handler plug plug Ewebmachine.Plug.Send # plug after that will be executed only if no ewebmachine resources has matched resource &quot;/hello/:name&quot; do %{name: name} after plug SomeAdditionnalPlug content_types_provided do: [&#39;application/xml&#39;: :to_xml] defh to_xml, do: &quot;&lt;Person&gt;&lt;name&gt;\#{state.name}&lt;/name&gt;&quot; end resource &quot;/*path&quot; do %{path: Enum.join(path,&quot;/&quot;)} after resource_exists do: File.regular?(path state.path) content_types_provided do: [{state.path|&gt;Plug.MIME.path|&gt;default_plain,:to_content}] defh to_content, do: File.stream!(path(state.path),[],300_000_000) defp path(relative), do: &quot;\#{:code.priv_dir :ewebmachine_example}/web/\#{relative}&quot; defp default_plain(&quot;application/octet-stream&quot;), do: &quot;text/plain&quot; defp default_plain(type), do: type end endCommon Plugs macro helperAs the most common use case is to match resources, run the webmachine automate, then set a 404 if no resource match, then handle error code, then send the response, the resources_plugs/1 macro allows you to do that.For example, if you want to convert all HTTP errors as Exceptions, and consider that all path must be handled and so any non matching path should return a 404 :resources_plugs error_as_exception: true, nomatch_404: trueis equivalent toplug :resource_match plug Ewebmachine.Plug.Run plug :wm_notset_404 plug Ewebmachine.Plug.ErrorAsException plug Ewebmachine.Plug.Send defp wm_notset_404(%{state: :unset}=conn,_), do: resp(conn,404,&quot;&quot;) defp wm_notset_404(conn,_), do: connAnother example, following plugs must handle non matching paths and errors should be converted into GET /error/:status that must be handled by following plugs :resources_plugs error_forwarding: &quot;/error/:status&quot;is equivalent toplug :resource_match plug Ewebmachine.Plug.Run plug Ewebmachine.Plug.ErrorAsForward, forward_pattern: &quot;/error/:status&quot; plug Ewebmachine.Plug.Send","ref":"Ewebmachine.Builder.Resources.html","title":"Ewebmachine.Builder.Resources","type":"module"},{"doc":"","ref":"Ewebmachine.Builder.Resources.html#resource/2","title":"Ewebmachine.Builder.Resources.resource/2","type":"macro"},{"doc":"Create a webmachine handler plug and use it on :resource_match when path matches the route will be the matching spec (see Plug.Router.match, string spec only)do_block will be called on match (so matching bindings will be available) and should return the initial stateafter_block will be the webmachine handler plug module body (wrapped with use Ewebmachine.Builder.Handlers and plug :add_handlers to clean the declaration.resource &quot;/my/route/:commaid&quot; do id = string.split(commaid,&quot;,&quot;) %{foo: id} after plug someadditionnalplug resource_exists do: state.id == [&quot;hello&quot;] end resource ShortenedRouteName, &quot;/my/route/that/would/generate/a/long/module/name/:commaid&quot; do id = String.split(commaid,&quot;,&quot;) %{foo: id} after plug SomeAdditionnalPlug resource_exists do: state.id == [&quot;hello&quot;] end","ref":"Ewebmachine.Builder.Resources.html#resource/3","title":"Ewebmachine.Builder.Resources.resource/3","type":"macro"},{"doc":"","ref":"Ewebmachine.Builder.Resources.html#resource_quote/5","title":"Ewebmachine.Builder.Resources.resource_quote/5","type":"function"},{"doc":"","ref":"Ewebmachine.Builder.Resources.html#resources_plugs/1","title":"Ewebmachine.Builder.Resources.resources_plugs/1","type":"macro"},{"doc":"HTTP utility module","ref":"Ewebmachine.Core.Utils.html","title":"Ewebmachine.Core.Utils","type":"module"},{"doc":"HTTP Charset negociation, get the charset to use from : acc_char_hdr, the HTTP header Accept-Charsetcharsets, the list of supported charsets","ref":"Ewebmachine.Core.Utils.html#choose_charset/2","title":"Ewebmachine.Core.Utils.choose_charset/2","type":"function"},{"doc":"HTTP Encoding negociation, get the encoding to use from : acc_enc_hdr, the HTTP header Accept-Encodingencs, the list of supported encoding","ref":"Ewebmachine.Core.Utils.html#choose_encoding/2","title":"Ewebmachine.Core.Utils.choose_encoding/2","type":"function"},{"doc":"HTTP Content negociation, get the content type to send from : accept_header, the HTTP header Acceptct_provided, the list of provided content types","ref":"Ewebmachine.Core.Utils.html#choose_media_type/2","title":"Ewebmachine.Core.Utils.choose_media_type/2","type":"function"},{"doc":"Convert rfc1123 or rfc850 to :calendar dates","ref":"Ewebmachine.Core.Utils.html#convert_request_date/1","title":"Ewebmachine.Core.Utils.convert_request_date/1","type":"function"},{"doc":"Format a norm_content_type into an HTTP content type header","ref":"Ewebmachine.Core.Utils.html#format_mtype/1","title":"Ewebmachine.Core.Utils.format_mtype/1","type":"function"},{"doc":"Match normalized media types accepting a partial match (wildcard or incomplete params)","ref":"Ewebmachine.Core.Utils.html#fuzzy_mt_match/2","title":"Ewebmachine.Core.Utils.fuzzy_mt_match/2","type":"function"},{"doc":"Get HTTP status label from HTTP code","ref":"Ewebmachine.Core.Utils.html#http_label/1","title":"Ewebmachine.Core.Utils.http_label/1","type":"function"},{"doc":"Convert any content type representation (see spec) into a norm_content_type","ref":"Ewebmachine.Core.Utils.html#normalize_mtype/1","title":"Ewebmachine.Core.Utils.normalize_mtype/1","type":"function"},{"doc":"Remove quotes from HTTP quoted string","ref":"Ewebmachine.Core.Utils.html#quoted_string/1","title":"Ewebmachine.Core.Utils.quoted_string/1","type":"function"},{"doc":"Convert a calendar date to a rfc1123 date string","ref":"Ewebmachine.Core.Utils.html#rfc1123_date/1","title":"Ewebmachine.Core.Utils.rfc1123_date/1","type":"function"},{"doc":"Get the string list from a comma separated list of HTTP quoted strings","ref":"Ewebmachine.Core.Utils.html#split_quoted_strings/1","title":"Ewebmachine.Core.Utils.split_quoted_strings/1","type":"function"},{"doc":"","ref":"Ewebmachine.Core.Utils.html#t:norm_content_type/0","title":"Ewebmachine.Core.Utils.norm_content_type/0","type":"type"},{"doc":"Implement the functions described below to make decisions in the HTTP decision tree :service_available/2resource_exists/2is_authorized/2forbidden/2allow_missing_post/2malformed_request/2uri_too_long/2known_content_type/2valid_content_headers/2valid_entity_length/2options/2allowed_methods/2known_methods/2content_types_provided/2content_types_accepted/2delete_resource/2delete_completed/2post_is_create/2create_path/2base_uri/2process_post/2language_available/2charsets_provided/2encodings_provided/2variances/2is_conflict/2multiple_choices/2previously_existed/2moved_permanently/2moved_temporarily/2last_modified/2expires/2generate_etag/2validate_content_checksum/2ping/2Body-producing function, see to_html/2 (but any function name can be used, as referenced by content_types_provided/2POST/PUT processing function, see from_json/2 (but any function name can be used, as referenced by content_types_accepted/2All the handlers have the same signature :(conn :: Plug.Conn.t,state :: any)-&gt;{response :: any | {:halt,200..599},conn :: Plug.Conn.t, state :: any}where every handler implementation : can change or halt the plug conn passed as argumentcan change the user state object passed from on handler to another in its argumentsreturns something which will make decision in the HTTP decision tree (see documentation of functions in this module to see expected results and effects)can return {:halt,200..599} to end the ewebmachine automate execution, but do not halt the conn, so the plug pipeline can continue.So each handler implementation is actually a &quot;plug&quot; returning a response giving information allowing to make the good response code and path in the HTTP specification.UsageThe following modules will help you to construct these handlers and use them :Ewebmachine.Builder.Handlers gives you macros and helpers to define the handlers and automatically create the plug to add them to your conn.private[:resource_handlers]Ewebmachine.Plug.Run run the HTTP decision tree executing the handler implementations described in its conn.private[:resource_handlers]. The initial user state is taken in conn.private[:machine_init]","ref":"Ewebmachine.Handlers.html","title":"Ewebmachine.Handlers","type":"module"},{"doc":"If the resource accepts POST requests to nonexistent resources, then this should return true.Default: false","ref":"Ewebmachine.Handlers.html#allow_missing_post/2","title":"Ewebmachine.Handlers.allow_missing_post/2","type":"function"},{"doc":"If a Method not in this list is requested, then a 405 Method Not Allowed will be sent. Note that these are all-caps Strings (binary).Default: [&quot;GET&quot;, &quot;HEAD&quot;]","ref":"Ewebmachine.Handlers.html#allowed_methods/2","title":"Ewebmachine.Handlers.allowed_methods/2","type":"function"},{"doc":"The base URI used in the location header on resource creation (when post_is_create is true), will be prepended to the create_path","ref":"Ewebmachine.Handlers.html#base_uri/2","title":"Ewebmachine.Handlers.base_uri/2","type":"function"},{"doc":"If this is anything other than the atom :no_charset, it must be a {key,value} Enumerable where key is the charset and value is a callable function in the resource which will be called on the produced body in a GET and ensure that it is in Charset.Default: :no_charset","ref":"Ewebmachine.Handlers.html#charsets_provided/2","title":"Ewebmachine.Handlers.charsets_provided/2","type":"function"},{"doc":"This is used similarly to content_types_provided, except that it is for incoming resource representations -- for example, PUT requests. Handler functions usually want to use Plug.read_body(conn) to access the incoming request body.Default: []","ref":"Ewebmachine.Handlers.html#content_types_accepted/2","title":"Ewebmachine.Handlers.content_types_accepted/2","type":"function"},{"doc":"This should return a key value tuple enumerable where the key is the content-type format and the value is an atom naming the function which can provide a resource representation in that media type. Content negotiation is driven by this return value. For example, if a client request includes an Accept header with a value that does not appear as a first element in any of the return tuples, then a 406 Not Acceptable will be sent.Default: [{&quot;text/html&quot;, to_html}]","ref":"Ewebmachine.Handlers.html#content_types_provided/2","title":"Ewebmachine.Handlers.content_types_provided/2","type":"function"},{"doc":"This will be called on a POST request if post_is_create returns true. It is an error for this function not to produce a Path if post_is_create returns true. The Path returned should be a valid URI part.","ref":"Ewebmachine.Handlers.html#create_path/2","title":"Ewebmachine.Handlers.create_path/2","type":"function"},{"doc":"This is only called after a successful delete_resource call, and should return false if the deletion was accepted but cannot yet be guaranteed to have finished.","ref":"Ewebmachine.Handlers.html#delete_completed/2","title":"Ewebmachine.Handlers.delete_completed/2","type":"function"},{"doc":"This is called when a DELETE request should be enacted, and should return true if the deletion succeeded.","ref":"Ewebmachine.Handlers.html#delete_resource/2","title":"Ewebmachine.Handlers.delete_resource/2","type":"function"},{"doc":"This must be a {key,value} Enumerable where key is a valid content encoding and value is a callable function in the resource which will be called on the produced body in a GET and ensure that it is so encoded. One useful setting is to have the function check on method, and on GET requests return:[identity: &amp;(&amp;1), gzip: &amp;:zlib.gzip/1] as this is all that is needed to support gzip content encoding. Default: [{&quot;identity&quot;, fn X-&gt; X end}]","ref":"Ewebmachine.Handlers.html#encodings_provided/2","title":"Ewebmachine.Handlers.encodings_provided/2","type":"function"},{"doc":"If not nil, set the expires headerDefault: nil","ref":"Ewebmachine.Handlers.html#expires/2","title":"Ewebmachine.Handlers.expires/2","type":"function"},{"doc":"Last handler, always called. Response is ignored except if it is a halt.","ref":"Ewebmachine.Handlers.html#finish_request/2","title":"Ewebmachine.Handlers.finish_request/2","type":"function"},{"doc":"Returning true will result in 403 Forbidden.Default: false","ref":"Ewebmachine.Handlers.html#forbidden/2","title":"Ewebmachine.Handlers.forbidden/2","type":"function"},{"doc":"Example POST/PUT processing function, function atom name must be referenced in content_types_accepted/2.It will be called when the request is PUT or when the request is POST and post_is_create returns true.","ref":"Ewebmachine.Handlers.html#from_json/2","title":"Ewebmachine.Handlers.from_json/2","type":"function"},{"doc":"If not nil, it will be used for the ETag header and for comparison in conditional requests.Default: nil","ref":"Ewebmachine.Handlers.html#generate_etag/2","title":"Ewebmachine.Handlers.generate_etag/2","type":"function"},{"doc":"If this returns anything other than true, the response will be 401 Unauthorized. The return value will be used as the value in the WWW-Authenticate header, for example Basic realm=&quot;Webmachine&quot;.Default: true","ref":"Ewebmachine.Handlers.html#is_authorized/2","title":"Ewebmachine.Handlers.is_authorized/2","type":"function"},{"doc":"If this returns true, the client will receive a 409 Conflict.Default : false","ref":"Ewebmachine.Handlers.html#is_conflict/2","title":"Ewebmachine.Handlers.is_conflict/2","type":"function"},{"doc":"Returning false will result in 415 Unsupported Media Type.Default: true","ref":"Ewebmachine.Handlers.html#known_content_type/2","title":"Ewebmachine.Handlers.known_content_type/2","type":"function"},{"doc":"Override the known methods accepted by your automateDefault: [&quot;GET&quot;, &quot;HEAD&quot;, &quot;POST&quot;, &quot;PUT&quot;, &quot;DELETE&quot;, &quot;TRACE&quot;, &quot;CONNECT&quot;, &quot;OPTIONS&quot;]","ref":"Ewebmachine.Handlers.html#known_methods/2","title":"Ewebmachine.Handlers.known_methods/2","type":"function"},{"doc":"return false if language in Plug.Conn.get_resp_header(conn,&quot;accept-language&quot;) is not available.","ref":"Ewebmachine.Handlers.html#language_available/2","title":"Ewebmachine.Handlers.language_available/2","type":"function"},{"doc":"If this returns a datetime() ({{day,month,year},{h,m,s}}, it will be used for the Last-Modified header and for comparison in conditional requests.Default: nil","ref":"Ewebmachine.Handlers.html#last_modified/2","title":"Ewebmachine.Handlers.last_modified/2","type":"function"},{"doc":"Returning true will result in 400 Bad Request.Default: false","ref":"Ewebmachine.Handlers.html#malformed_request/2","title":"Ewebmachine.Handlers.malformed_request/2","type":"function"},{"doc":"If this returns {true, uri}, the client will receive a 301 Moved Permanently with uri in the Location header.Default: false","ref":"Ewebmachine.Handlers.html#moved_permanently/2","title":"Ewebmachine.Handlers.moved_permanently/2","type":"function"},{"doc":"If this returns {true, uri}, the client will receive a 307 Temporary Redirect with uri in the Location header.Default: false","ref":"Ewebmachine.Handlers.html#moved_temporarily/2","title":"Ewebmachine.Handlers.moved_temporarily/2","type":"function"},{"doc":"If this returns true, then it is assumed that multiple representations of the response are possible and a single one cannot be automatically chosen, so a 300 Multiple Choices will be sent instead of a 200 OK.Default: false","ref":"Ewebmachine.Handlers.html#multiple_choices/2","title":"Ewebmachine.Handlers.multiple_choices/2","type":"function"},{"doc":"If the OPTIONS method is supported and is used, the return value of this function is expected to be a list of pairs representing header names and values that should appear in the response.","ref":"Ewebmachine.Handlers.html#options/2","title":"Ewebmachine.Handlers.options/2","type":"function"},{"doc":"Must be present and returning pong to prove that handlers are well linked to the automate","ref":"Ewebmachine.Handlers.html#ping/2","title":"Ewebmachine.Handlers.ping/2","type":"function"},{"doc":"If POST requests should be treated as a request to put content into a (potentially new) resource as opposed to being a generic submission for processing, then this function should return true. If it does return true, then create_path will be called and the rest of the request will be treated much like a PUT to the Path entry returned by that call.Default: false","ref":"Ewebmachine.Handlers.html#post_is_create/2","title":"Ewebmachine.Handlers.post_is_create/2","type":"function"},{"doc":"If this returns true, the moved_permanently and moved_temporarily callbacks will be invoked to determine whether the response should be 301 Moved Permanently, 307 Temporary Redirect, or 410 Gone.Default: false","ref":"Ewebmachine.Handlers.html#previously_existed/2","title":"Ewebmachine.Handlers.previously_existed/2","type":"function"},{"doc":"If post_is_create returns false, then this will be called to process any POST requests. If it succeeds, it should return true.","ref":"Ewebmachine.Handlers.html#process_post/2","title":"Ewebmachine.Handlers.process_post/2","type":"function"},{"doc":"Returning non-true values will result in 404 Not Found.Default: true","ref":"Ewebmachine.Handlers.html#resource_exists/2","title":"Ewebmachine.Handlers.resource_exists/2","type":"function"},{"doc":"Returning non-true values will result in 503 Service Unavailable.Default: true","ref":"Ewebmachine.Handlers.html#service_available/2","title":"Ewebmachine.Handlers.service_available/2","type":"function"},{"doc":"Example body-producing function, function atom name must be referenced in content_types_provided/2.If the result is an Enumerable of iodata, then the HTTP response will be a chunk encoding response where each chunk on element of the enumeration.If the result is an iodata, then it is used as the HTTP response body","ref":"Ewebmachine.Handlers.html#to_html/2","title":"Ewebmachine.Handlers.to_html/2","type":"function"},{"doc":"Returning true will result in 414 Request-URI Too Long.Default: false","ref":"Ewebmachine.Handlers.html#uri_too_long/2","title":"Ewebmachine.Handlers.uri_too_long/2","type":"function"},{"doc":"Returning false will result in 501 Not Implemented.Default: true","ref":"Ewebmachine.Handlers.html#valid_content_headers/2","title":"Ewebmachine.Handlers.valid_content_headers/2","type":"function"},{"doc":"Returning false will result in 413 Request Entity Too Large.Default: false","ref":"Ewebmachine.Handlers.html#valid_entity_length/2","title":"Ewebmachine.Handlers.valid_entity_length/2","type":"function"},{"doc":"if content-md5 header exists: If :not_validated, test if input body validate content-md5,if return false, then return a bad requestUseful if content-md5 validation does not imply only raw md5 hash","ref":"Ewebmachine.Handlers.html#validate_content_checksum/2","title":"Ewebmachine.Handlers.validate_content_checksum/2","type":"function"},{"doc":"If this function is implemented, it should return a list of strings with header names that should be included in a given response's Vary header. The standard conneg headers (Accept, Accept-Encoding, Accept-Charset, Accept-Language) do not need to be specified here as Webmachine will add the correct elements of those automatically depending on resource behavior.Default : []","ref":"Ewebmachine.Handlers.html#variances/2","title":"Ewebmachine.Handlers.variances/2","type":"function"},{"doc":"","ref":"Ewebmachine.Handlers.html#t:conn/0","title":"Ewebmachine.Handlers.conn/0","type":"type"},{"doc":"","ref":"Ewebmachine.Handlers.html#t:halt/0","title":"Ewebmachine.Handlers.halt/0","type":"type"},{"doc":"","ref":"Ewebmachine.Handlers.html#t:state/0","title":"Ewebmachine.Handlers.state/0","type":"type"},{"doc":"A ewebmachine debug UI at /wm_debugAdd it before Ewebmachine.Plug.Run in your plug pipeline when you want debugging facilities.if Mix.env == :dev, do: plug Ewebmachine.Plug.DebugThen go to http://youhost:yourport/wm_debug, you will see the request list since the launch of your server. Click on any to get the ewebmachine debugging UI. The list will be automatically updated on new query.The ewebmachine debugging UI shows you the HTTP decision path taken by the request to the response. Everythe red decisions are the one where decisions differs from the default one because of a handler implementation :click on them, then select any handler available in the right tab to see the conn, state inputs of the handler and the response.The response and request right tab shows you the request and result at the end of the ewebmachine run.click on &quot;auto redirect on new query&quot; and at every request, your browser will navigate to the debugging UI of the new request (you can still use back/next to navigate through requests)","ref":"Ewebmachine.Plug.Debug.html","title":"Ewebmachine.Plug.Debug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Ewebmachine.Plug.Debug.html#call/2","title":"Ewebmachine.Plug.Debug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Ewebmachine.Plug.Debug.html#init/1","title":"Ewebmachine.Plug.Debug.init/1","type":"function"},{"doc":"This plug take an argument forward_pattern (default to &quot;/error/:status&quot;), and, when the current response status is an error, simply forward to a GET to the path defined by the pattern and this status.","ref":"Ewebmachine.Plug.ErrorAsForward.html","title":"Ewebmachine.Plug.ErrorAsForward","type":"module"},{"doc":"Plug passing your conn through the HTTP decision tree to fill its status and response. This plug does not send the HTTP result, instead the conn result of this plug must be sent with the plug Ewebmachine.Plug.Send. This is useful to customize the Ewebmachine result after the run, for instance to customize the error body (void by default).Decisions are make according to handlers set in conn.private[:resource_handlers] (%{handler_name: handler_module}) where handler_name is one of the handler function of Ewebmachine.Handlers and handler_module is the module implementing it.Initial user state (second parameter of handler function) is taken from conn.private[:machine_init] Ewebmachine.Builder.Handlers :add_handler plug allows you to set these parameters in order to use this Plug. A successfull run will reset the resource handlers and initial state.","ref":"Ewebmachine.Plug.Run.html","title":"Ewebmachine.Plug.Run","type":"module"},{"doc":"Calling this plug will send the response and halt the connection pipeline if the conn has passed through an Ewebmachine.Plug.Run.","ref":"Ewebmachine.Plug.Send.html","title":"Ewebmachine.Plug.Send","type":"module"},{"doc":"This plug checks the current response status. If it is an error, raise a plug exception with the status code and the HTTP error name as the message. If this response body is not void, use it as the exception message.","ref":"Ewebmachine.Plug.ErrorAsException.html","title":"Ewebmachine.Plug.ErrorAsException","type":"exception"},{"doc":"","ref":"Ewebmachine.Plug.ErrorAsException.html#call/2","title":"Ewebmachine.Plug.ErrorAsException.call/2","type":"function"},{"doc":"","ref":"Ewebmachine.Plug.ErrorAsException.html#init/1","title":"Ewebmachine.Plug.ErrorAsException.init/1","type":"function"}]